<script setup lang="ts">
import { ref } from 'vue'
import commonToast from '@/components/common-toast.vue'
import { useToastStore } from '@/stores/toast'

const inputValue = ref('')
const toastStore = useToastStore()
const toastSetting = ref<'success' | 'error'>('error')

const fixBtn = {
  add: false,
  edit: true,
  delete: true
}

const tableHeaders = reactive([
  { title: '產品代號' },
  { title: '產品品名' },
  { title: '產品簡稱' },
  { title: 'Inactive?' }
])

const tableData = reactive([
  {
    productCode: 'U44B11',
    productName: 'DT全名',
    productAbbreviation: 'DT',
    isInactive: false
  },
  {
    productCode: 'U44B11',
    productName: 'DT全名',
    productAbbreviation: 'DT',
    isInactive: false
  },
  {
    productCode: 'U44B11',
    productName: 'DT全名',
    productAbbreviation: 'DT',
    isInactive: false
  }
])

const pageObj = reactive({
  pageItems: 10, // 一頁秀幾筆
  currentPage: 1, // 當前頁數
  pageSize: 5 // 分頁中間數字最多顯示的數目
})

// 總頁數
const totalPage = computed(() => {
  return Math.ceil(tableData.length / pageObj.pageItems)
})

const nowPage = computed(() => {
  const min = (pageObj.currentPage - 1) * pageObj.pageItems
  const max = min + pageObj.pageItems - 1
  return { min, max }
})

// 篩出來渲染的資料
const showData = computed(() => {
  return tableData.filter((item, index) => {
    return index >= nowPage.value.min && index < nowPage.value.max + 1
  })
})

const onEdit = (val: any) => {
  console.log('parent edit', val)
}

const onDelete = (val: any) => {
  console.log('parent delete', val)
}

const turnPage = (val: any) => {
  pageObj.currentPage = val
}

const search = () => {}
</script>

<template>
  <main class="container-fluid">
    <header>
      <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
          <li class="font-zh-small-regular breadcrumb-item">
            <a href="#">基本資料</a>
          </li>
          <li
            aria-current="page"
            class="font-zh-small-regular breadcrumb-item active"
          >
            產品
          </li>
        </ol>
      </nav>
      <div class="d-flex justify-content-end w-100">
        <img
          alt="header-illustration"
          class="header-illustration"
          src="@/assets/images/header-illustration.svg"
        />
      </div>
      <div class="function-group">
        <div class="display-info">
          <h3 class="font-zh-h3">產品查詢</h3>
          <div class="interact-button-list d-flex">
            <button
              class="btn btn-middle-gray-200 font-zh-button d-flex justify-content-center align-items-center"
              type="button"
            >
              <p>新增</p>
              <div class="icon-create"></div>
            </button>
          </div>
        </div>
      </div>
    </header>
    <div class="single-operation-board card">
      <h3 class="font-zh-h3 text-color-main">查詢條件</h3>
      <form>
        <div class="card-body">
          <div class="input-item-list row">
            <div class="col-3">
              <div class="input-item">
                <label class="font-zh-p-medium form-label" for="userAccount"
                  >產品代號</label
                >
                <common-input v-model="inputValue" />
              </div>
            </div>
            <div class="col-3">
              <div class="input-item">
                <label class="font-zh-p-medium form-label" for="userPassword"
                  >產品簡稱</label
                >
                <common-input v-model="inputValue" />
              </div>
            </div>
          </div>
          <div class="row align-items-end">
            <div class="col-3">
              <div class="form-check-group">
                <p class="font-en-p-medium">Inactive?</p>
                <div class="form-check-list d-flex justify-content-between">
                  <div class="form-check">
                    <input
                      id="flexRadioDefault1"
                      class="form-check-input"
                      name="flexRadioDefault"
                      type="radio"
                    />
                    <label
                      class="font-en-p-medium form-check-label"
                      for="flexRadioDefault1"
                    >
                      Inactive
                    </label>
                  </div>
                  <div class="form-check">
                    <input
                      id="flexRadioDefault2"
                      class="form-check-input"
                      name="flexRadioDefault"
                      type="radio"
                    />
                    <label
                      class="font-en-p-medium form-check-label"
                      for="flexRadioDefault2"
                    >
                      Active
                    </label>
                  </div>
                </div>
              </div>
            </div>
            <div class="col-3">
              <div class="d-grid gap-2">
                <button
                  class="btn btn-large-secondary font-zh-button d-flex justify-content-center align-items-center"
                  type="button"
                  @click="search"
                >
                  <p>查詢</p>
                  <div class="icon-search"></div>
                </button>
              </div>
            </div>
          </div>
        </div>
      </form>
    </div>
    <div>
      <basic-table
        :fix-btn="fixBtn"
        :table-data="showData"
        :table-headers="tableHeaders"
        @delete="onDelete"
        @edit="onEdit"
      />
      <table-pagination
        :page-obj="pageObj"
        :total-page="totalPage"
        @turn-page="turnPage"
      />
    </div>
  </main>

  <common-toast :toast-setting="toastSetting" />
</template>

<style lang="scss" scoped>
/** style */
</style>
